CON

 

   Nunchuck_Addr = $A4
{______ 
| 1 2 3  |
|          |
| 6 5 4  |
|_-----_|



1 - green - data
2 - nothing
3 - red - 3.3+v
4 - yellow - clock
5 - nothing
6 - white - ground

}
OBJ
   i2cObject      : "i2cObject"

VAR
   byte joy_x
   byte joy_y
   word accel_x
   word accel_y
   word accel_z
   byte button_c
   byte button_z                                                                                
   long _220uS
   byte i2cSCL, i2cSDA
PUB init(_slc, _sda)
   i2cSCL := _slc
   i2cSDA := _sda
   i2cObject.Init(i2cSDA, i2cSCL, false)
   _220uS := clkfreq / 100_000 * 22 
  
PUB readNunchuck | data[6]
   i2cObject.writeLocation(Nunchuck_Addr, $40, $00, 8, 8)
   waitcnt(_220uS+cnt)
   i2cObject.i2cStart
   i2cObject.i2cWrite(Nunchuck_Addr, 8)
   i2cObject.i2cWrite(0,8)
   i2cObject.i2cStop
   waitcnt(_220uS+cnt)
   i2cObject.i2cStart
   i2cObject.i2cWrite(Nunchuck_Addr|1, 8)
   data[0] := (i2cObject.i2cRead(0) ^ $17) + $17
   data[1] := (i2cObject.i2cRead(0) ^ $17) + $17 
   data[2] := (i2cObject.i2cRead(0) ^ $17) + $17 
   data[3] := (i2cObject.i2cRead(0) ^ $17) + $17 
   data[4] := (i2cObject.i2cRead(0) ^ $17) + $17 
   data[5] := (i2cObject.i2cRead(1) ^ $17) + $17
   i2cObject.i2cStop
   joy_x := data[0]
   joy_y := data[1]
   accel_x := data[2] << 2
   accel_y := data[3] << 2
   accel_z := data[4] << 2
   button_z := 1- (data[5]  & 1)
   button_c := 1 - ((data[5] >> 1) & 1)
   if (data[5] >> 2) & 1
      accel_x += 2                                                                               
   if (data[5] >> 3) & 1
      accel_x += 1                                                                               
   if (data[5] >> 4) & 1
      accel_y += 2                                                                               
   if (data[5] >> 5) & 1
      accel_y += 1                                                                               
   if (data[5] >> 6) & 1
      accel_z += 2                                                                               
   if (data[5] >> 7) & 1
      accel_z += 1

PUB joyX
   return joy_x

PUB joyY
   return joy_y

PUB accelX
   return accel_x

PUB accelY
   return accel_y

PUB accelZ
   return accel_z

PUB buttonC
   return button_c

PUB buttonZ
   return button_z